@use './breakpoints' as bp;

/**
 * Helpers for mediaqueries based on screen size.
 * Usage:
 *   Red text on medium and large screens:
 *       @include(medium-up) { color: red }
 *   Blue text on small and medium screens
 *       @include(medium) { color: blue }
 *
 * Source: https://www.sitepoint.com/managing-responsive-breakpoints-sass/
 */
@mixin respond-to($name) {
  @if map-has-key(bp.$media-queries, $name) {
    @media #{inspect(map-get(bp.$media-queries, $name))} {

      // Dump block
      @content;
    }
  }

  @else {
    // stylelint-disable scss/operator-no-newline-after
    @warn 'Unfortunately, no value could be retrieved from `#{$name}`.' +
      'Please make sure it is defined in `$bp-aliases` map.';
    // stylelint-enable scss/operator-no-newline-after
  }
}

/**
  Helper to generate responsive variants

  Params:
    $class: The class name
    $less:  True or false - whether to generate variants for "size or less"
            instead of "size or up" (default)
  Usage:
    @include responds-to-variants(up, my-selector)
    => .-sm:my-selector
    => .-md:my-selector
    => .-lg:my-selector
    @include responds-to-variants(less, my-selector)
    => .-sm-less:my-selector
    => .-md-less:my-selector
    => .-lg-less:my-selector
*/
@mixin responds-to-variants($class, $less: false){
  @each $bp, $bpv in bp.$breakpoints {
    $size: "min-width: #{$bpv}";
    $variant: '';

    @if ($less) {
      $size: "max-width: #{$bpv - 1}";
      $variant: '-l'
    }

    @media($size) {
      .-#{$bp}#{$variant}\:#{$class} {
        @content
      }
    }
  }
}

/**
 * Adds everything needed to hide the content and let screen readers access it
 */
@mixin sr-only() {
  // stylelint-disable declaration-no-important
  position: absolute !important;
  overflow: hidden !important;
  width: 1px !important;
  height: 1px !important;
  padding: 0 !important;
  border: 0 !important;
  clip: rect(0, 0, 0, 0) !important;
  // stylelint-enable declaration-no-important
}

@mixin thumbnail($width, $height) {
  overflow: hidden;
  width: 100%;
  max-width: $width;
  height: 100%;
  max-height: $height;

  img {
    width: 100%;
    max-width: $width;
    height: 100%;
    object-fit: cover;
  }
}
